% ph_resize.m
% Routine called by 'Resize' menu item in photo editor.
%
% Nick Kingsbury, Cambridge University, November 2005.

% Open new fig window for entering params

figure(2);
cf = gcf;
set(gcf,'position',[400  624  260  100]);
set(gcf,'numbertitle','off','name','Resize Image');

sx = size(xui);

% Set default size to that of xui and default scale to 1.
if exist('newsize') ~= 1, newsize = [sx(1:2) 1]; end

label = ['Ysize:';'Xsize:';'Scale:'];
for k = 1:3
    edbox(k) = uicontrol(gcf,'style','edit','pos',[70 20*k-10 60 20]);
    uicontrol(gcf,'style','text','str',label(k,:),'pos',[10 20*k-10 60 20]);
end
curvals = sprintf('Current values: Xsize = %d; Ysize = %d',sx(2),sx(1));
uicontrol(gcf,'style','text','str',curvals,'pos',[10 70 240 20]);

resizenow = uicontrol(gcf,'str','Resize now','pos',[160 40 80 20]);
accpt = uicontrol(gcf,'str','Accept','pos',[180 10 60 20]);

% Call-back strings for any update of newsize.
% Update directly from Xsize or Ysize boxes.
cb1 = 'for k=1:2, newsize(k)=round(sscanf(get(edbox(k),''string''),''%f'')); end;';
% Update from Scale box.
cb2 = ['newsize(3) = sscanf(get(edbox(3),''string''),''%f'');'...
       'newsize(1:2) = round(newsize(3) * sx(1:2));'];
% Insert correct values in boxes
cb3 = ['for k=1:2; set(edbox(k),''string'',sprintf(''%d'',newsize(k))); end;'...
       'set(edbox(3),''string'',sprintf(''%.2f'',newsize(3)));'];
% Perform resizing and show images.
cb4 = 'yui = im_resize(xui,newsize(1:2)); showimages;';
eval(cb3);

% Assign call-back strings to buttons.
for k = 1:2, set(edbox(k),'call',[cb1 cb3]); end
set(edbox(3),'call',[cb2 cb3]);
set(resizenow,'call',[cb1 cb4]);
set(accpt,'call','xui=yui; close(gcf); showimages;');
